> ## Documentation Index
> Fetch the complete documentation index at: https://developer.copper.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Execute exchange action

> Execute Hyperliquid exchange action. Mimics https://hyperliquid.gitbook.io/hyperliquid-docs/for-developers/api/exchange-endpoint



## OpenAPI

````yaml /copper-open-api-public.json post /exchange
openapi: 3.1.0
info:
  description: >-
    Copper API is based on the REST API interface provided for data exchange
    between a client and a server with the use of HTTPS requests and responses.

    By default, the request should include a Content-Type header set as
    application/json. Some requests require different header fields, as well as
    other Content-Type values. In this case, a proper header will be stated in
    an example.

    When interacting with the API, please note that all numerical values, such
    as order amounts or timestamps, should be transmitted as strings. This
    ensures consistent data representation and prevents potential issues with
    floating-point precision
  title: Copper Platform API
  version: latest
servers:
  - description: platform.copper.co
    url: https://api.copper.co/platform
  - description: demo.copper.co
    url: https://api.stage.copper.co/platform
  - description: testnet.copper.co
    url: https://api.testnet.copper.co/platform
security: []
tags:
  - name: reports
  - name: deposit-targets
  - name: lending
  - name: portfolios
  - name: wallets
  - name: network
  - name: stake
  - name: blockchain
  - name: organizations
  - name: files
  - name: orders
  - name: address-book
  - name: clearloop
  - name: hyperliquid
  - name: currencies
paths:
  /exchange:
    post:
      tags:
        - hyperliquid
      summary: Execute exchange action
      description: >-
        Execute Hyperliquid exchange action. Mimics
        https://hyperliquid.gitbook.io/hyperliquid-docs/for-developers/api/exchange-endpoint
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/HyperliquidExchangeRequest'
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HyperliquidExchangeResponse'
          description: OK
        '400':
          content:
            application/json:
              schema:
                properties:
                  error:
                    description: The machine-readable error code
                    examples:
                      - bad-request
                    type: string
                  message:
                    description: >-
                      A human-readable message providing more details about the
                      error
                    type: string
                type: object
          description: Bad Request
        '403':
          content:
            application/json:
              schema:
                properties:
                  error:
                    description: The machine-readable error code
                    examples:
                      - forbidden
                    type: string
                  message:
                    description: >-
                      A human-readable message providing more details about the
                      error
                    type: string
                type: object
          description: Forbidden
        '409':
          content:
            application/json:
              schema:
                properties:
                  error:
                    description: The machine-readable error code
                    examples:
                      - conflict
                    type: string
                  message:
                    description: >-
                      A human-readable message providing more details about the
                      error
                    type: string
                type: object
          description: Conflict
components:
  schemas:
    HyperliquidExchangeRequest:
      properties:
        action:
          $ref: '#/components/schemas/L1Action'
          description: >-
            Exchange action; follows Hyperliquid specification documented at
            https://hyperliquid.gitbook.io/hyperliquid-docs/for-developers/api/exchange-endpoint
          type: object
        organizationId:
          description: Your Copper organisation identifier
          type: string
        portfolioId:
          description: The specific portfolio from which the trade should be executed
          type: string
      type: object
    HyperliquidExchangeResponse:
      properties: {}
      type: object
    L1Action:
      properties: {}
      type: object

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.